<?php
/* $Id: index.php 3160 2009-04-23 14:06:52Z vadim $ */

//     index.php   
//  "    "  require/index.php
//  ,       " 
// "  ..
define("NC_AUTH_IN_PROGRESS", 1);

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($INCLUDE_FOLDER."index.php");

if ($logoff) {
	Unauthorize();
	
	if ($REQUESTED_FROM) {
		if ($REQUESTED_BY == 'POST') $redirect = "http://".$HTTP_HOST."/";
		else $redirect = "http://".$HTTP_HOST.$REQUESTED_FROM;
	}
	
	if ($REDIRECT_STATUS=='on') {
		header("Location:".$redirect);
	} else {
		eval("echo \"$template_header\";");
		printf(NETCAT_MODULE_AUTH_MSG_SESSION_CLOSED, $REQUESTED_FROM);
		eval("echo \"$template_footer\";");
	}
	exit;
}

$open_id = '';

if ( $_GET['openid_mode'] && nc_auth_openid_possibility() ) {
  // include OpenID classes
  nc_auth_openid_do_includes();

  $consumer = nc_auth_openid_get_consumer();

  //   ,   .
  $return_to = nc_auth_openid_get_return_to();
  $return_to.= "?".$QUERY_STRING;

  $response = $consumer->complete($return_to);

  //   
  if ($response->status == Auth_OpenID_CANCEL) {
      // This means the authentication was cancelled.
      $msg = NETCAT_MODULE_AUTH_OPEN_ID_CHECK_CANCELED;
  }
  else if ($response->status == Auth_OpenID_FAILURE) {
      // OpenID   ; display the error message.
      $msg = sprintf(NETCAT_MODULE_AUTH_OPEN_ID_AUTH_FAILED, $response->message);
  }
  else if ($response->status == Auth_OpenID_SUCCESS) {
    // This means the authentication succeeded; extract the
    // identity URL and Simple Registration data (if it was
    // returned).
    $openid = $response->getDisplayIdentifier();
    $esc_identity = htmlspecialchars($openid, ENT_QUOTES);

    //$sreg_resp = Auth_OpenID_SRegResponse::fromSuccessResponse($response);
    //$sreg = $sreg_resp->contents();

    $open_id = nc_auth_normalize_openid_url($_GET['openid_identity']);
    $query_where_cat = $MODULE_VARS['auth']['USER_BIND_TO_CATALOGUE'] ? " AND `Catalogue_ID` IN(0, ".$catalogue.")" : "";
    $res = $db->query("SELECT User.User_ID FROM `User`, `User_OpenID`
      WHERE `Checked` = 1 AND User_OpenID.User_ID=User.User_ID AND `OpenID` = '".$open_id."'".$query_where_cat);
    $IsAuthorized = $db->num_rows;
    if ($IsAuthorized) $AuthPhase = 1;

    //    OpenID   
    $success = sprintf(NETCAT_MODULE_AUTH_OPEN_ID_AUTH_COMPLETE_NAME, $esc_identity, $esc_identity);
    preg_match("/https?:\/\/(.*?)\//",$esc_identity,$find);
    $shortid = $find[1];
    $mylogin = sprintf(NETCAT_MODULE_AUTH_OPEN_ID_AUTH_COMPLETE_LOGIN, $shortid);
  }

}

$openid_url = $_POST['openid_url'] ? $_POST['openid_url'] : ($_GET['openid_url'] ? $_GET['openid_url'] : "");

if ( $openid_url && nc_auth_openid_possibility() ) {

  if ( !$db->get_var("SELECT `User_ID` FROM `User_OpenID` WHERE `OpenID` = '".nc_auth_normalize_openid_url($_POST['openid_url'])."'") ) {
    $warnText = NETCAT_MODULE_AUTH_OPEN_ID_ERROR;
  }
  else { 
   	// include OpenID classes
  	nc_auth_openid_do_includes();
		
		$consumer = nc_auth_openid_get_consumer();

    // Begin the OpenID authentication process.
    $auth_request = $consumer->begin($openid_url);

    // No auth request means we can't begin OpenID.
    if (!$auth_request) {
      $warnText = NETCAT_MODULE_AUTH_OPEN_ID_INVALID;
    }

    $sreg_request = Auth_OpenID_SRegRequest::build(
		 	// Required
		 	array('nickname'),
		 	// Optional
		 	array('fullname', 'email')
		);

    if ($sreg_request) {
      $auth_request->addExtension($sreg_request);
    }

    //$policy_uris = $_GET['policies'];

    //$pape_request = new Auth_OpenID_PAPE_Request($policy_uris);
    //if ($pape_request) {
     //   $auth_request->addExtension($pape_request);
    //}

    // Redirect the user to the OpenID server for authentication.
    // Store the token for this authentication so we can verify the
    // response.

    // For OpenID 1, send a redirect.  For OpenID 2, use a Javascript
    // form to send a POST request to the server.
    if ( $auth_request->shouldSendRedirect() ) {
			$redirect_url = $auth_request->redirectURL( nc_auth_openid_get_trust_root(), nc_auth_openid_get_return_to() );

			// If the redirect URL can't be built, display an error
			// message.
			if ( Auth_OpenID::isFailure($redirect_url) ) {
					$warnText = sprintf(NETCAT_MODULE_AUTH_OPEN_ID_COULD_NOT_REDIRECT_TO_SERVER, $redirect_url->message);
			}
			else {
				// Send redirect.
				header("Location: ".$redirect_url);
			}
    }
		else {
			// Generate form markup and render it.
			$form_id = 'openid_message';
			$form_html = $auth_request->htmlMarkup( nc_auth_openid_get_trust_root(), nc_auth_openid_get_return_to(), false, array('id' => $form_id) );
			// Display an error if the form markup couldn't be generated;
			// otherwise, render the HTML.
			if ( Auth_OpenID::isFailure($form_html) ) {
				$warnText = sprintf(NETCAT_MODULE_AUTH_OPEN_ID_COULD_NOT_REDIRECT_TO_SERVER, $form_html->message);
			}
      else {
				print $form_html;
			}
    }	
  }
}

if ($AuthPhase && !$_GET['openid_mode']) {
	$query_where_cat = $MODULE_VARS['auth']['USER_BIND_TO_CATALOGUE'] ? " AND `Catalogue_ID` IN (0, ".$catalogue.")" : "";
	$res = $db->query("SELECT `User_ID` FROM `User`
    WHERE ".$db->escape($AUTHORIZE_BY)." = '".$db->escape($AUTH_USER)."'
    AND `Password` = PASSWORD('".$AUTH_PW."')
    AND `Checked` = 1".$query_where_cat);
	$IsAuthorized = $db->num_rows;
}

if (!$AuthPhase || !$IsAuthorized) {
	eval("echo \"$template_header\";");
	UserLoginForm();
	eval("echo \"$template_footer\";");
}
else {
	Authorize(0, $open_id);
	
	if ($REQUESTED_BY=='GET') $redirect = "http://".$HTTP_HOST.$REQUESTED_FROM;
	else $redirect = "http://".$HTTP_HOST."/";
	
	$ProjectDomain = GetAllProjectDomains();
	
	$Password = $db->get_var("SELECT PASSWORD('${AUTH_PW}')");
	
	if ($REDIRECT_STATUS == 'on') {
		if ($AUTHORIZATION_TYPE == 'session') {
			if (substr($redirect,-1)!='l' && substr($redirect,-1)!='/') {$redirect .= ("&".session_name()."=".session_id()); } else { $redirect .= ("?".session_name()."=".session_id()); }
		}
		header('Location:'.$redirect);		
	}
	else {
		eval("echo \"$template_header\";");
		printf(NETCAT_MODULE_AUTH_MSG_AUTH_SUCCESS, $REQUESTED_FROM);
		eval("echo \"$template_footer\";");
	}
}

?>
